#include <stdlib.h>
#include <stdio.h>
#include <math.h>
#include <string.h>


int spheres[26][4];
double x_,y_,dx_,dy_,nx_,ny_;
int lasthit;
int n;

// #define _DEBUG_

int hitsphere(void){
	double maxdist = 0;
	int spherehit = -2;
	int i;
	
	double t1,t2,maxt,x0mxs,y0mys,a_,b_,c_,D;
	
	maxt = 1000;
	
	//printf("lasthit: %d\n",lasthit);
	
	for (i=0;i<n;i++){
	if (i!= lasthit){
		x0mxs = x_ - spheres[i][0];
		y0mys = y_ - spheres[i][1];
		
		a_ = dx_*dx_ + dy_*dy_;
		b_ = 2*(y0mys*dy_ + x0mxs*dx_);
		c_ = x0mxs*x0mxs + y0mys*y0mys - spheres[i][2]*spheres[i][2];
		
		//printf("abc %lf,%lf,%lf\n",a_,b_,c_);
		
		D = b_*b_ - 4*a_*c_;
		//printf("DDD: %lf\n",D);
		if (D>=0){
			if (a_ != 0){
		
			D = sqrt(D);
			if (D == 0){
				t1 = t2 = (- b_)/(2*a_);
			} else {
				t1 = ( -b_ -D)/(2*a_);
				t2 = (-b_ +D)/(2*a_);
			}
			
			if (!((t1 < t2) && (t1>0))) t1 = t2;
			} else {
				t1 = (-c_)/b_;
			}
			//printf("%lf,%lf\n",t1,t2);
			
			
			if ((t1 > 0) && (t1<maxt)){
			//printf("low: %lf\n",t1);
				maxt = t1;
				spherehit = i;
			}
			//printf("gizmo: %lf\n",t1);
		}
	}
	}
	
	if (spherehit >= 0){
		x_ = x_ + maxt*dx_;
		y_ = y_ +maxt*dy_;
		
		a_ = x_ - spheres[spherehit][0];
		b_ = y_ - spheres[spherehit][1];
		
		c_ = ((dx_ * a_) + (dy_ * b_));
		D = ((-dx_ * b_) + (dy_ * a_));
		
		//printf("c_: %lf, d: %lf\n",c_,D);
		
		nx_ = c_*c_ - D*D;
		D = 2*c_*D;
		c_ = nx_;
		
		//printf("c_: %lf, d: %lf\n",c_,D);
		nx_ = c_*dx_ + D*dy_;
		ny_ = D*dx_ - c_*dy_;
		
		
		a_ = sqrt(ny_*ny_+nx_*nx_);
		dx_ = -nx_/a_;
		dy_ = ny_/a_;
		
		
	}
		
		
		
	return spherehit;		
		
		




}



int main(void){
  int x,y,dx,dy,hit,scene,i;

	scene = 0;
  scanf("%d\n",&n);
  while (n!=0){
  	scene++;
  	//memset(spheres,0,sizeof(spheres));
  //	printf("a, %d\n",n);
  	for (i=0;i<n;i++) scanf("%d %d %d\n",&spheres[i][0],&spheres[i][1],&spheres[i][2]);
  	  	//printf("b\n");

  	scanf("%d %d %d %d\n",&x,&y,&dx,&dy);
  	x_ = (double)x;
  	y_ = (double)y;
  	dx_ = (double)dx;
  	dy_ = (double)dy;
  	hit = 0;
  	lasthit = -1;
  	printf("Scene %d\n",scene);
  	while (hit<10){
  	  	
  	  lasthit = hitsphere();
  	 #ifdef _DEBUG_
  	 	printf("hit: %d\n",lasthit);
  	 	printf("x: %lf y: %lf dx: %lf dy %lf\n",x_,y_,dx_,dy_);
  	 #endif
  	  if (lasthit==-2) break;
  	  hit++;
  	  printf("%d ",lasthit+1);
  	  
  	}
  	
  	if (lasthit == -2) printf("inf\n\n");
  	else printf("...\n\n");
  	
  	scanf("%d\n",&n);
  	
  	
  	
  
  
  }
	
	
	  
 



}
